FROM python:3.12.2-slim
ENV FLYWHEEL="/flywheel/v0"
RUN mkdir -p ${FLYWHEEL}
WORKDIR ${FLYWHEEL}

# version to install
ENV FSL_VERSION=6.0.7.7

RUN apt-get update \
    && apt-get install -y \
        wget \
        bc \
        dc

# get the fslinstaller.py from official repo, v3.9.0 of fslinstaller.py
RUN wget -O /tmp/fslinstaller.py https://git.fmrib.ox.ac.uk/fsl/conda/installer/-/raw/3.9.0/fsl/installer/fslinstaller.py

# # install
RUN python /tmp/fslinstaller.py --fslversion=${FSL_VERSION} -d /usr/share/fsl/

# # Set environment variables
ENV FSLDIR=/usr/share/fsl
ENV FSL_DIR="${FSLDIR}"
ENV PATH=/usr/share/fsl/bin:$PATH
ENV FSLMULTIFILEQUIT=TRUE
ENV LD_LIBRARY_PATH=/usr/share/fsl/lib:$LD_LIBRARY_PATH
ENV FSLOUTPUTTYPE=NIFTI_GZ

COPY run.py ${FLYWHEEL}/
COPY fsl_siena ${FLYWHEEL}/fsl_siena

COPY requirements.txt $FLYWHEEL/
RUN pip install --no-cache-dir -r $FLYWHEEL/requirements.txt

LABEL org.nrg.commands="[{\"name\": \"fsl-siena\", \"label\": \"fsl-siena\", \"description\": \"Runs fsl-siena v1.0. LICENSING NOTE: FSL software are owned by Oxford University Innovation and license is required for any commercial applications. For commercial licence please contact fsl@innovation.ox.ac.uk. For academic use, an academic license is required which is available by registering on the FSL website. Any use of the software requires that the user obtain the appropriate license. See https://fsl.fmrib.ox.ac.uk/fsldownloads_registration for more information.\", \"version\": \"1.0\", \"schema-version\": \"1.0\", \"image\": \"registry.gitlab.com/flywheel-io/clinical-solutions/xnat-cs-containers/fsl-siena:1.0\", \"type\": \"docker\", \"command-line\": \"python run.py --scan1_mnt /scan1 --scan2_mnt /scan2 --output_dir /output #PROJECT# #T2# #SESSION1# #SESSION2# #SCAN1# #SCAN2# #VMASK# #DEBUG# #BET_OPTS# #CLASS_SEG# #IGNORE_TOP# #IGNORE_BOTTOM# #STANDARD_SPC_MASK# #SIENA_DIFF_OPTS# #VENTRICLE# \", \"override-entrypoint\": true, \"mounts\": [{\"name\": \"out\", \"writable\": true, \"path\": \"/output\"}, {\"name\": \"scan1\", \"writable\": false, \"path\": \"/scan1\"}, {\"name\": \"scan2\", \"writable\": false, \"path\": \"/scan2\"}], \"environment-variables\": {}, \"ports\": {}, \"inputs\": [{\"name\": \"T2\", \"description\": \"Tell FAST that both input scans are T2w, not T1w. Choose 'False' if both scans are T1w, 'True' if both are T2w. Corresponds to -t2 in siena.\", \"type\": \"select-one\", \"default-value\": \"\", \"required\": true, \"replacement-key\": \"#T2#\", \"command-line-flag\": \"-t2\", \"command-line-separator\": \" \", \"select-values\": [\"False\", \"True\", \"\"]}, {\"name\": \"SESSION1\", \"label\": \"Session1:\", \"type\": \"string\", \"required\": true, \"replacement-key\": \"#SESSION1#\", \"command-line-flag\": \"--session1\", \"command-line-separator\": \" \", \"select-values\": []}, {\"name\": \"SESSION2\", \"label\": \"Session2:\", \"type\": \"string\", \"required\": true, \"replacement-key\": \"#SESSION2#\", \"command-line-flag\": \"--session2\", \"command-line-separator\": \" \", \"select-values\": []}, {\"name\": \"SCAN1\", \"label\": \"Scan1:\", \"type\": \"string\", \"required\": true, \"replacement-key\": \"#SCAN1#\", \"command-line-flag\": \"--scan1\", \"command-line-separator\": \" \", \"select-values\": []}, {\"name\": \"SCAN2\", \"label\": \"Scan2:\", \"type\": \"string\", \"required\": true, \"replacement-key\": \"#SCAN2#\", \"command-line-flag\": \"--scan2\", \"command-line-separator\": \" \", \"select-values\": []}, {\"name\": \"Debug\", \"description\": \"Don't delete intermediate files. Corresponds to -d in siena.\", \"type\": \"boolean\", \"default-value\": \"false\", \"required\": false, \"replacement-key\": \"#DEBUG#\", \"true-value\": \"-d\", \"false-value\": \"\", \"select-values\": []}, {\"name\": \"Single_class_segmentation\", \"description\": \"Don\u2019t segment gray and white matter, and segment as a single class (gray and white together). This is a good option if the gray-white matter contrast is poor. Corresponds to -2 in siena.\", \"type\": \"boolean\", \"default-value\": \"false\", \"required\": false, \"replacement-key\": \"#CLASS_SEG#\", \"true-value\": \"-2\", \"false-value\": \"\", \"select-values\": []}, {\"name\": \"Standard_space_masking\", \"description\": \"Use standard-space masking as well as BET. If it is proving hard to get reliable brain segmentation from BET, for example if eyes are hard to segment out then register to standard space in order to use a pre-defined standard-space brain mask. Corresponds to -m in siena.\", \"type\": \"boolean\", \"default-value\": \"false\", \"required\": false, \"replacement-key\": \"#STANDARD_SPC_MASK#\", \"true-value\": \"-m\", \"false-value\": \"\", \"select-values\": []}, {\"name\": \"Ventricle_analysis\", \"description\": \"Run ventricle analysis \u201cVIENA\u201d (quantifies ventricular siena). Corresponds to -V in siena.\", \"type\": \"boolean\", \"default-value\": \"false\", \"required\": false, \"replacement-key\": \"#VENTRICLE#\", \"true-value\": \"-V\", \"false-value\": \"\", \"select-values\": []}, {\"name\": \"Ventricle_mask\", \"description\": \"Ventricle mask full filename encapsulated by quotes. This file should be saved under the 'SIENA' project resource. e.g, 'the_ventricle_mask.nii.gz'  Corresponds to -v in siena. By default siena will use MNI152_T1_2mm_VentricleMask.nii.gz \", \"type\": \"string\", \"default-value\": \"\", \"required\": false, \"replacement-key\": \"#VMASK#\", \"command-line-flag\": \"-v\", \"command-line-separator\": \" \", \"select-values\": []}, {\"name\": \"BET_options\", \"description\": \"Options to pass to BET, encapsulated by quotes. e.g,'-f 0.3 -g 0.6'. Corresponds to -B in siena.\", \"type\": \"string\", \"default-value\": \"\", \"required\": false, \"replacement-key\": \"#BET_OPTS#\", \"command-line-flag\": \"-B\", \"command-line-separator\": \"=\", \"select-values\": []}, {\"name\": \"Siena_diff_options\", \"description\": \"Options to pass to siena_diff program, that estimates change between two aligned images, encapsulated by quotes, e.g, '-s -i 20'.  Corresponds to -S in siena.\", \"type\": \"string\", \"default-value\": \"\", \"required\": false, \"replacement-key\": \"#SIENA_DIFF_OPTS#\", \"command-line-flag\": \"-S\", \"command-line-separator\": \"=\", \"select-values\": []}, {\"name\": \"Ignore_top\", \"description\": \"Ignore from t (mm) upwards in MNI152/Talairach space. If you need to ignore the top part of the head (e.g. if some subjects have the top missing and you need consistency across subjects). Corresponds to -t in siena.\", \"type\": \"number\", \"default-value\": \"\", \"required\": false, \"replacement-key\": \"#IGNORE_TOP#\", \"command-line-flag\": \"-t\", \"command-line-separator\": \" \", \"select-values\": []}, {\"name\": \"Ignore_bottom\", \"description\": \"Ignore from b (mm) downwards in MNI152/Talairach space (b should probably be negative). Corresponds to -b in siena.\", \"type\": \"number\", \"default-value\": \"\", \"required\": false, \"replacement-key\": \"#IGNORE_BOTTOM#\", \"command-line-flag\": \"-b\", \"command-line-separator\": \"=\", \"select-values\": []}, {\"name\": \"PROJECT\", \"label\": \"Project:\", \"type\": \"string\", \"required\": true, \"replacement-key\": \"#PROJECT#\", \"command-line-flag\": \"--project\", \"command-line-separator\": \" \", \"select-values\": []}], \"outputs\": [{\"name\": \"output\", \"description\": \"output\", \"required\": true, \"mount\": \"out\"}], \"xnat\": [{\"name\": \"fsl-siena\", \"description\": \"Runs fsl-siena v1.0\", \"contexts\": [\"xnat:subjectData\"], \"external-inputs\": [{\"name\": \"subject\", \"description\": \"Input subject\", \"type\": \"Subject\", \"required\": true, \"load-children\": false}], \"derived-inputs\": [{\"name\": \"Session_1\", \"type\": \"Session\", \"required\": true, \"provides-value-for-command-input\": \"SESSION1\", \"load-children\": true, \"derived-from-wrapper-input\": \"subject\", \"multiple\": false}, {\"name\": \"Anatomical_scan1\", \"type\": \"Scan\", \"required\": true, \"provides-value-for-command-input\": \"SCAN1\", \"provides-files-for-command-mount\": \"scan1\", \"load-children\": true, \"derived-from-wrapper-input\": \"Session_1\", \"multiple\": false}, {\"name\": \"Session_2\", \"type\": \"Session\", \"required\": true, \"provides-value-for-command-input\": \"SESSION2\", \"load-children\": true, \"derived-from-wrapper-input\": \"subject\", \"multiple\": false}, {\"name\": \"Anatomical_scan2\", \"type\": \"Scan\", \"required\": true, \"provides-value-for-command-input\": \"SCAN2\", \"provides-files-for-command-mount\": \"scan2\", \"load-children\": true, \"derived-from-wrapper-input\": \"Session_2\", \"multiple\": false}, {\"name\": \"project-id\", \"description\": \"Project id\", \"type\": \"string\", \"required\": true, \"provides-value-for-command-input\": \"PROJECT\", \"load-children\": true, \"derived-from-wrapper-input\": \"subject\", \"derived-from-xnat-object-property\": \"project-id\", \"multiple\": false}], \"output-handlers\": [{\"name\": \"siena-output\", \"accepts-command-output\": \"output\", \"as-a-child-of\": \"subject\", \"type\": \"Resource\", \"label\": \"SIENA\", \"tags\": []}]}], \"reserve-memory\": 2000, \"container-labels\": {}, \"generic-resources\": {}, \"ulimits\": {}, \"secrets\": []}]"